import Cookies from 'js-cookie'
import { Notification } from 'element-ui'

const app = {
  state: {
    client: null,
    sidebar: {
      opened: !+Cookies.get('sidebarStatus'),
      withoutAnimation: false
    },
    device: 'desktop',
    language: Cookies.get('language') || 'zh'
  },
  mutations: {
    TOGGLE_SIDEBAR: state => {
      if (state.sidebar.opened) {
        Cookies.set('sidebarStatus', 1)
      } else {
        Cookies.set('sidebarStatus', 0)
      }
      state.sidebar.opened = !state.sidebar.opened
      state.sidebar.withoutAnimation = false
    },
    CLOSE_SIDEBAR: (state, withoutAnimation) => {
      Cookies.set('sidebarStatus', 1)
      state.sidebar.opened = false
      state.sidebar.withoutAnimation = withoutAnimation
    },
    TOGGLE_DEVICE: (state, device) => {
      state.device = device
    },
    SET_LANGUAGE: (state, language) => {
      state.language = language
      Cookies.set('language', language)
    },
    SHOW_ROOM: (state, room) => {
      state.dialogVisible = true
      state.globleRoom = room
    },
    HIDE_ROOM: (state) => {
      state.dialogVisible = false
    },
    SHOW_WXNOTIFY: (state) => {
      // if (state.wxNoify.visible) return
      console.log(Notification)
      state.wxNoify = Notification.info({
        iconClass: 'iconfont icon-auth',
        title: '提醒',
        dangerouslyUseHTMLString: true,
        customClass: 'authNotify',
        duration: 0,
        message: `有新的待授权用户需处理`,
        position: 'bottom-right'
      })
    }
  },
  actions: {
    toggleSideBar ({ commit }) {
      commit('TOGGLE_SIDEBAR')
    },
    closeSideBar ({ commit }, { withoutAnimation }) {
      commit('CLOSE_SIDEBAR', withoutAnimation)
    },
    toggleDevice ({ commit }, device) {
      commit('TOGGLE_DEVICE', device)
    },
    setLanguage ({ commit }, language) {
      commit('SET_LANGUAGE', language)
    },
    showRoom ({ commit }, room) {
      commit('SHOW_ROOM', room)
    },
    hideRoom ({ commit }) {
      commit('HIDE_ROOM')
    }
  }
}

export default app
